Option Explicit
Const VPinMAMEDriverVer = 2.3
'=======================
' VPinMAME driver code.
'=======================
' New in 2.3
'   - Default dip switch dialogue created for most games
'   - vpmMoveBall uses default ball colour and image if activeball is not available
' New in 2.24
'   - New class cvpmDips
'   - New functions vpmSolMoveWall, vpmSolMoveObj
' New in 2.23
'   - New class cvpmVLock
'   - New function vpmMoveBall
'   - Separated reset and update objs
' New in 2.22
'   - Added vpmMechFast & vpmMechStepSw
' New in 2.21
'   - Corrected bug where SCoin became required
'
' Put this at the top of the table file
'LoadVPM "02000000", "xxx.VBS", 2.3
'Const cGameName    = "xxxx" ' PinMAME short game name
'Const UseSolenoids = True
'Const UseLamps     = True
''Standard sound
'Const SSolenoidOn  = "SolOn"       'Solenoid activates
'Const SSolenoidOff = "SolOff"      'Solenoid deactivates
'Const SFlipperOn   = "FlipperUp"   'Flipper activated
'Const SFlipperOff  = "FlipperDown" 'Flipper deactivated
'Const SCoin        = "Quarter"     'Coin inserted
''Callbacks
'Set LampCallback   = GetRef("UpdateMultipleLamps")
'Set GICallback     = GetRef("UpdateGI")
'Set MotorCallback  = GetRef("UpdateMotors")
'
'Sub LoadVPM(VPMver, VBSfile, VBSver)
'	On Error Resume Next
'		If ScriptEngineMajorVersion < 5 Then MsgBox "VB Script Engine 5.0 or higher required"
'		ExecuteGlobal CreateObject("Scripting.FileSystemObject").OpenTextFile(VBSfile, 1).ReadAll
'		If Err Then MsgBox "Unable to open " & VBSfile & ". Ensure that it is in the same folder as this table. " & vbNewLine & Err.Description : Err.Clear
'		Set Controller = CreateObject("VPinMAME.Controller")
'		If Err Then MsgBox "Can't Load VPinMAME." & vbNewLine & Err.Description
'		If VPMver>"" Then If Controller.Version < VPMver Or Err Then MsgBox "VPinMAME ver " & VPMver & " required." : Err.Clear
'		If VPinMAMEDriverVer < VBSver Or Err Then MsgBox VBSFile & " ver " & VBSver & " or higher required."
'	On Error Goto 0
'End Sub
'
'Sub Table_KeyDown(ByVal keycode)
'	If vpmKeyDown(keycode) Then Exit Sub
'	If keycode = PlungerKey Then Plunger.Pullback
'End Sub
'Sub Table_KeyUp(ByVal keycode)
'	If vpmKeyUp(keycode) Then Exit Sub
'	If keycode = PlungerKey Then Plunger.Fire
'End Sub
'
'Const cCredits  = ""
'Sub Table_Init
'	On Error Resume Next
'		With Controller
'			.GameName = cGameName
'			If Err Then MsgBox "Can't start Game" & cGameName & vbNewLine & Err.Description : Exit Sub
'			.SplashInfoLine = cCredits
'			.HandleMechanics = 0
'			.ShowDMDOnly = True
'			.ShowFrame = False
'			.ShowTitle = False
'			.Run
'			If Err Then MsgBox Err.Description
'		End With
'	On Error Goto 0
'' Nudging
'	vpmNudge.TiltSwitch = swTilt
'	vpmNudge.Sensitivity = 5
'	vpmNudge.TiltObj = Array(Bumper1,Bumper2,LeftslingShot,RightslingShot)
'' Map switches and lamps
'	vpmCreateEvents colSwObjects ' collection of triggers etc
'	vpmMapLights	colLamps     ' collection of all lamps
'' Trough handler
'	Set bsTrough = New cvpmBallStack
'	bsTrough.InitNoTrough BallRelease, swOuthole, 90, 2
'	'or
'	bsTrough.InitSw swOuthole,swTrough1,swTrough2,0,0,0,0
'---------------------------------------------------------------
Dim Controller   ' VPinMAME Controller Object
Dim vpmTimer     ' Timer Object
Dim vpmNudge     ' Nudge handler Object
Dim Lights(160)  ' Put all lamps in an array for easier handling
Dim vpmMultiLights() ' If more than one lamp is connected fill
ReDim vpmMultiLights(0) ' this an array of each light
Dim vpmBallColour, vpmBallImage ' Default ball properties
vpmBallColour = vbWhite : vpmBallImage = ""
Private gNextMechNo ' keep track of created mech handlers (would be nice with static members)
gNextMechNo = 0

' Callbacks
Dim SolCallback(64) ' Solenoids (parsed at Runtime)
Dim LampCallback    ' Called after lamps are updated
Dim GICallback      ' Called for each changed GI String
Dim MotorCallback   ' Called after solenoids are updated
' Game specific info
Dim ExtraKeyHelp    ' Help string for game specific keys
Dim vpmShowDips     ' Show DIPs function
'-----------------------------------------------------------------------------
' These helper function requires the following objects on the table:
'   PinMAMETimer   : Timer object
'   PulseTimer     : Timer object
'   vpmFastTimer   : Timer object (only required for magnets and turntables)
'
' Available classes:
' ------------------
' cvpmTimer (Object = vpmTimer)
'   (Public)  .PulseSwitch   - pulse switch and call callback after delay (default)
'   (Public)  .PulseSw       - pulse switch
'   (Public)  .AddTimer      - call callback after delay
'   (Public)  .Reset         - Re-set all ballStacks
'   (Friend)  .AddUpdateObj  - add a update object (e.g. vpmBallStack instance)
'   (Private) .Update        - called from timer event
'
' cvpmBallStack (Create as many as needed)
'   (Public) .InitSw        - init switches used in stack
'   (Public) .InitSaucer    - init saucer
'   (Public) .InitNoTrough  - init a single ball, no trough handler
'   (Public) .InitKick      - init exit kicker

'   (Public) .InitAltKick   - init second kickout direction
'   (Public) .KickZ         - Z axis kickout angle (radians)
'   (Public) .KickBalls     - Maximum number of balls kicked out at the same time
'   (Public) .KickForceVar  - Initial ExitKicker Force value varies by this much (+/-, minimum force = 1)
'   (Public) .KickAngleVar  - ExitKicker Angle value varies by this much (+/-)
'   (Public) .BallColour    - Set ball colour
'   (Public) .TempBallImage  - Set ball image for next ball only
'   (Public) .TempBallColour - Set ball colour for next ball only
'   (Public) .BallImage     - Set ball image
'   (Public) .InitEntrySnd  - Sounds for Entry kicker
'   (Public) .InitExitSnd   - Sounds for Entry kicker
'   (Public) .AddBall       - add ball in "kicker" to stack
'   (Public) .SolIn         - Solenoid handler for entry solenoid
'   (Public) .EntrySol_On   - entry solenoid fired
'   (Public) .SolOut        - Solenoid handler for exit solenoid
'   (Public) .SolOutAlt     - Solenoid handler for exit solenoid 2nd direction
'   (Public) .ExitSol_On    - exit solenoid fired
'   (Public) .ExitAltSol_On - 2nd exit solenoid fired
'   (Public) .Balls         - get/set number of balls in stack (default)
'   (Public) .BallsPending  - get number of balls waiting to come in to stack
'   (Public) .Reset         - reset and update all ballstack switches
'   (Friend) .Update        - Update ball positions (from vpmTimer class)
'  Obsolete
'   (Public) .SolExit       - exit solenoid handler
'   (Public) .SolEntry      - Entry solenoid handler
'   (Public) .InitProxy     - Init proxy switch

' cvpmNudge (Object = vpmNudge)
'   Hopefully we can add a real pendulum simulator in the future
'   (Public)  .TiltSwitch   - set tilt switch
'   (Public)  .Senitivity   - Set tiltsensitivity (0-10)
'   (Public)  .TiltObj      - Set objects affected by tilt
'   (Public)  .DoNudge dir,power  - Nudge table
'   (Public)  .SolGameOn    - Game On solenoid handler
'   (Private) .Update       - Handle tilting
'
' cvpmDropTarget (create as many as needed)
'   (Public)  .InitDrop     - initialise DropTarget bank
'   (Public)  .CreateEvents - Create Hit events
'   (Public)  .InitSnd      - sound to use for targets
'   (Public)  .AnyUpSw      - Set AnyUp switch
'   (Public)  .AllDownSw    - Set all down switch
'   (Public)  .Hit          - A target had been hit
'   (Public)  .SolHit       - Solenoid handler for dropping a target
'   (Public)  .SolUnHit     - Solenoid handler for raising a target
'   (Public)  .SolDropDown  - Solenoid handler for Bank down
'   (Public)  .SolDropUp    - Solenoid handler for Bank reset
'   (Public)  .DropSol_On   - Reset target bank
'
' cvpmMagnet (create as many as needed)
'   (Public)  .InitMagnet   - initialise magnet
'   (Public)  .CreateEvents - Create Hit/Unhit events
'   (Public)  .Solenoid     - Set solenoid that controls magnet
'   (Public)  .GrabCenter   - Magnet grabs ball at center
'   (Public)  .MagnetOn     - Turn magnet on and off
'   (Public)  .X            - Move magnet
'   (Public)  .Y            - Move magnet
'   (Public)  .Strength     - Change strength
'   (Public)  .Size         - Change magnet reach
'   (Public)  .AddBall      - A ball has come withing range
'   (Public)  .RemoveBall   - A ball is out of reach for the magnet
'   (Public)  .Balls        - Balls currently within magnets reach
'   (Public)  .AttractBall  - attract ball to magnet
'   (Private) .Update       - update all balls (called from timer)
'   (Private) .Reset        - handle emulation reset
'  Obsolete
'   (Public)  .Range        - Change magnet reach

' cvpmTurnTable (create as many as needed)
'   (Public)  .InitTurnTable - initialise turntable
'   (Public)  .CreateEvents  - Create Hit/Unhit events
'   (Public)  .MaxSpeed      - Maximum speed
'   (Public)  .SpinUp        - Speedup acceleration
'   (Public)  .SpinDown      - Retardation
'   (Public)  .Speed         - Current speed
'   (Public)  .MotorOn       - Motor On/Off
'   (Public)  .SpinCW        - Control direction
'   (Public)  .SolMotor      - Motor on/off solenoid handler
'   (Public)  .AddBall       - A ball has come withing range
'   (Public)  .RemoveBall    - A ball is out of reach for the magnet
'   (Public)  .Balls         - Balls currently within magnets reach
'   (Public)  .AffectBall    - affect a ball
'   (Private) .Update        - update all balls (called from timer)
'   (Private) .Reset         - handle emulation reset

' cvpmMech (create as many as needed)
'   (Public)  .Sol1, Sol2    - Controlling solenoids
'   (Public)  .MType         - type of mechanics
'   (Public)  .Length, Steps
'   (Public)  .Acc, Ret      - Acceleration, retardation
'   (Public)  .AddSw         - Automaticaly controlled switches
'   (Public)  .CallBack      - Update graphics function
'   (Public)  .Start         - Start mechanics handler
'   (Public)  .Position      - Current position
'   (Public)  .Speed         - Current Speed
'   (Private) .Update
'   (Private) .Reset
'
' cvpmCaptiveBall (create as many as needed)
'   (Public)  .InitCaptive   - Initialise captive balls
'   (Public)  .ForceTrans    - Amount of force tranferred to captive ball (0-1)
'   (Public)  .MinForce      - Minimum force applied to the ball
'   (Public)  .RestSwitch    - Switch activated when ball is in rest position
'   (Public)  .BallImage     - Image of captive ball (specify before InitCaptive)
'   (Public)  .BallColour    - Colour of captive ball (specify before InitCaptive)
'   (Public)  .Start         - Create moving ball etc.
'   (Public)  .CreateEvents  - Create events for captive ball
'   (Public)  .TrigHit       - trigger in front of ball hit (or unhit)
'   (Public)  .BallHit       - Wall in front of ball hit
'   (Public)  .BallReturn    - Captive ball has returned to kicker
'
' cvpmVLock (create as many as needed)
'   (Public)  .InitVLock
'   (Public)  .ExitDir
'   (Public)  .ExitForce
'   (Public)  .KickForceVar
'   (Public)  .Balls
'   (Public)  .SolExit
'   (Public)  .CreateEvents
'   (Public)  .TrigHit
'   (Public)  .TrigUnhit
'   (Public)  .KickHit
'
' Generic solenoid handlers:
' --------------------------
' vpmSolFlipper flipObj1, flipObj2  - "flips flippers". Set unused to Nothing
' vpmSolDiverter divObj, sound      - open/close diverter (flipper) with/without sound
' vpmSolWall wallObj, sound         - Raise/Drop wall with/without sound
' vpmSolToggleWall wall1, wall2, sound - Toggle between two walls
' vpmSolToggleObj obj1,obj2,sound   - Toggle any objects
' vpmSolAutoPlunger plungerObj      - Autoplunger/kickback
' vpmSolGate obj, sound             - Open/close gate
' vpmSolSound sound                 - Play sound only
' vpmFlasher flashObj               - Flashes flasher
'
' Generating events:
' ------------------
' vpmCreateEvents
' cpmCreateLights
'
' Variables declared (to be filled in):
' ---------------------------------------
' SolCallback()  - handler for each solenoid
' Lights()       - Lamps
'
' Constants used (must be defined):
' ---------------------------------
' UseSolenoids   - Update solenoids
' MotorCallback  - Called once every update for mechanics or custom sol handler
' UseLamps       - Update lamps
' LampCallback   - Sub to call after lamps are updated
'                  (or every update if UseLamps is false)
' GICallback     - Sub to call to update GI strings
' SFlipperOn     - Flipper activate sound
' SFlipperOff    - Flipper deactivate sound
' SSolenoidOn    - Solenoid activate sound
' SSolenoidOff   - Solenoid deactivate sound
' SCoin          - Coin Sound
' ExtraKeyHelp   - Game specific keys in help window
'
' Exported variables:
' -------------------
' vpmTimer      - Timer class for PulsSwitch etc
' vpmNudge      - Class for table nudge handling
'-----------------------------------------------------
Private Const PinMameInterval = 1 ' Lights/solnoids run as quick as possible

Private Const conStackSw    = 7  ' Stack switches
Private Const conMaxBalls   = 10
Private Const conMaxTimers  = 20 ' Spinners can generate a lot of timers
Private Const conTimerPulse = 40 ' Timer runs at 25Hz
Private Const conFastTicks  = 8  ' Fast is 8 times per timer pulse

Private Const conSwPulse    = 1  ' Length of switch pulse
Private Const conMaxSwHit   = 5  ' Don't stack up more that 5 events for each switch

'--------------------
'       Timer
'--------------------
Class cvpmTimer
	Private cTime(), cDelay(), cSw(), cCallback(), cNow, cTimers
	Private cUpdateObjs, cFUpdateObjs, cResetObjs
	Private cTick, cFast, cTimerObj

	Private Sub Class_Initialize
		ReDim cTime(conMaxTimers), cDelay(conMaxTimers), cSw(conMaxTimers), cCallback(conMaxTimers)
		Set cUpdateObjs  = CreateObject("Scripting.Dictionary")
		Set cFUpdateObjs = CreateObject("Scripting.Dictionary")
		Set cResetObjs = CreateObject("Scripting.Dictionary")
		cNow = 0 : cTimers = 0 : cTick = 0 : cTimerObj = False
	End Sub

	Private Sub DeleteTimer(aPos)
		Dim ii
		cTimers = cTimers - 1
		For ii = aPos To cTimers
			cTime(ii) = cTime(ii+1) : cSw(ii) = cSw(ii+1) : cCallback(ii) = cCallback(ii+1) : cDelay(ii) = cDelay(ii+1)
		Next
	End sub

	Public Sub InitTimer(obj)
		Set cTimerObj = obj
		If vpmNoMTimer And cFast Then obj.Interval = conTimerPulse \ conFastTicks Else obj.Interval = conTimerPulse
		obj.Enabled = True
	End Sub

	Public Sub Reset
		Dim obj : For Each obj In cResetObjs.Keys : obj.Reset : Next
	End Sub

	Public Sub UpdateFast
		Dim obj : For Each obj In cFUpdateObjs.Keys : obj.Update : Next
	End Sub

	Public Sub Update
		Dim ii, jj, sw, obj
		If cFast Then UpdateFast : cTick = (cTick + 1) Mod conFastTicks : If cTick Then Exit Sub
		For Each obj In cUpdateObjs.Keys : obj.Update : Next
		If cTimers = 0 Then Exit Sub
		cNow = cNow + 1
		For ii = 1 To cTimers ' Set pending switches
			If cSw(ii) < 0 Then cSw(ii) = -cSw(ii) : Controller.Switch(cSw(ii)) = True : cTime(ii) = cNow + conSwPulse
		Next
		ii = 1
		Do While ii <= cTimers
			If cTime(ii) = cNow Then ' Timer has expired
				sw = cSw(ii)

				If cDelay(ii) Then
					If sw Then Controller.Switch(sw) = False : cTime(ii) = cNow + cDelay(ii) : cDelay(ii) = 0
				Else
					If varType(cCallback(ii)) = vbString And cCallback(ii) > "" Then Execute cCallback(ii) & " " & sw & " "
					DeleteTimer ii : ii = ii - 1
				End If
				If sw > 0 Then ' Check if there are more timers for this switch
					For jj = ii+1 To cTimers
						If sw = cSw(jj) And cDelay(jj) > 0 Then cSw(jj) = -cSw(jj) : Exit For
					Next
				End If
			End If
			ii = ii + 1
		Loop
	End Sub

	Public Sub AddUpdateObj(aObj, aFast)
		If aFast Then
			cFUpdateObjs.Add aObj, aFast
			If vpmNoMTimer And Not cFast Then cFast = True : If IsObject(cTimerObj) Then cTimerObj.Interval = conTimerPulse \ conFastTicks
		Else
			cUpdateObjs.Add aObj, aFast
		End If
	End Sub

	Public Sub AddResetObj(aObj)  : cResetObjs.Add aObj, 0 : End Sub

	Public Sub PulseSw(aSwNo) : PulseSwitch aSwNo, 0, 0 : End Sub

	Public Default Sub PulseSwitch(aSwNo, aDelay, aCallback)
		Dim ii, count
		count = 0
		For ii = 1 To cTimers
			If (cSw(ii) = aSwNo Or cSw(ii) = -aSwNo) And cDelay(ii) > 0 Then count = count + 1
		Next
		If count >= conMaxSwHit Or cTimers = conMaxTimers Then Exit Sub
		cTimers = cTimers + 1 : cCallback(cTimers) = aCallback
		If count Then
			cTime(cTimers) = 0 : cSw(cTimers) = aSwNo
		Else
			cTime(cTimers) = cNow + conSwPulse : cSw(cTimers) = -aSwNo
		End If
		If aDelay < conTimerPulse Then cDelay(cTimers) = 1 Else cDelay(cTimers) = aDelay \ conTimerPulse
	End Sub

	Public Sub AddTimer(aDelay, aCallback)
		If cTimers = conMaxTimers Then Exit Sub
		cTimers = cTimers + 1
		cSw(cTimers) = 0 : cCallback(cTimers) = aCallback : cDelay(cTimers) = 0
		If aDelay \ conTimerPulse = 0 Then aDelay = conTimerPulse
		cTime(cTimers) = cNow + aDelay \ conTimerPulse :
	End Sub
End Class

'--------------------
'     BallStack
'--------------------
Class cvpmBallStack
	Private cSw(), cEntrySw, cBalls, cBallIn, cBallPos(), cUpdate, cSaucer
	Private cInitKicker, cExitKicker, cExitDir, cExitForce
	Private cExitDir2, cExitForce2
	Private cBColour, cBImage, cTBColour, cTBImage
	Private cEntrySnd, cEntrySndBall, cExitSnd, cExitSndBall
	Public KickZ, KickBalls, KickForceVar, KickAngleVar, TempBallColour, TempBallImage

	Private Sub Class_Initialize
		ReDim cSw(conStackSw), cBallPos(conMaxBalls)
		cBallIn = 0 : cBalls = 0 : cUpdate = False
		cExitKicker = 0 : cInitKicker = 0 : kickballs = 1 : cSaucer = False
		cExitDir = 0 : cExitForce = 0 : cExitDir2 = 0 : cExitForce2 = 0 : KickZ = 0
		KickForceVar = 0 : KickAngleVar = 0
		cBColour = Empty : cBImage = Empty : TempBallColour = cBColour : TempBallImage = cBImage
		cEntrySnd = 0 : cEntrySndBall = 0 : cExitSnd = 0 : cExitSndBall = 0
		vpmTimer.AddUpdateObj Me, False : vpmTimer.AddResetObj Me
	End Sub

	Private Function SetSw(aNo, aStatus)
		SetSw = False : If aNo <= conStackSw Then If cSw(aNo) Then Controller.Switch(cSw(aNo)) = aStatus : SetSw = True
	End Function

	Public Sub Reset
		Dim ii : If cBalls Then For ii = 1 to cBalls : SetSw cBallPos(ii), True : Next
	End Sub

	Public Sub Update
		Dim BallQue, ii
		If cUpdate Then cUpdate = False Else Exit Sub
		BallQue = 1
		For ii = 1 To cBalls
			If cBallpos(ii) > BallQue Then
				SetSw cBallPos(ii), False
				Do
					cBallPos(ii) = cBallPos(ii) - 1
				Loop Until SetSw(cBallPos(ii), True) Or cBallPos(ii) = BallQue
				cUpdate = True
			End If
			BallQue = cBallPos(ii) + 1
		Next
	End Sub

	Public Sub AddBall(aKicker)
		If isObject(aKicker) Then
			If cSaucer Then
				If aKicker Is cExitKicker Then
					cExitKicker.Enabled = False : cInitKicker = 0
				Else
					aKicker.Enabled = False : Set cInitKicker = aKicker
					If VPSupBallObj Then With ActiveBall : TempBallColour = .Color : TempBallImage = .Image : End With
				End If
			Else
				aKicker.DestroyBall
			End If
		ElseIf cSaucer Then
			cExitKicker.Enabled = False : cInitKicker = 0
		End If
		If cEntrySw Then
			Controller.Switch(cEntrySw) = True : cBallIn = cBallIn + 1
		Else
			cBalls = cBalls + 1 : cBallPos(cBalls) = conStackSw + 1 : cUpdate = True
		End If
	End Sub
	' A bug in the script engine forces the "End If" at the end
	Public Sub SolIn(aEnabled)     : If aEnabled Then KickIn        : End If : End Sub
	Public Sub SolOut(aEnabled)    : If aEnabled Then KickOut False : End If : End Sub
	Public Sub SolOutAlt(aEnabled) : If aEnabled Then KickOut True  : End If : End Sub
	Public Sub EntrySol_On   : KickIn        : End Sub
	Public Sub ExitSol_On    : KickOut False : End Sub
	Public Sub ExitAltSol_On : KickOut True  : End Sub

	Private Sub KickIn
		If cBallIn Then PlaySound cEntrySndBall Else PlaySound cEntrySnd : Exit Sub
		cBalls = cBalls + 1 : cBallIn = cBallIn - 1 : cBallPos(cBalls) = conStackSw + 1 : cUpdate = True
		If cEntrySw And cBallIn = 0 Then Controller.Switch(cEntrySw) = False
	End Sub

	Private Sub KickOut(aAltSol)
		Dim ii,jj, kForce, kDir, kBaseDir

		If cBalls Then PlaySound cExitSndBall Else PlaySound cExitSnd : Exit Sub
		If aAltSol Then kForce = cExitForce2 : kBaseDir = cExitDir2 Else kForce = cExitForce : kBaseDir = cExitDir
		kForce = kForce + (Rnd - 0.5)*KickForceVar
		If cSaucer Then
			SetSw 1, False : cBalls = 0 : kDir = kBaseDir + (Rnd - 0.5)*KickAngleVar
			If isObject(cInitKicker) Then
				If VPSupBallObj Then
					With cExitKicker.CreateBall : .Color = TempBallColour : .Image = TempBallImage : End With
				Else
					cExitKicker.CreateBall
				End If
				cInitKicker.Destroyball : cInitKicker.Enabled = True
			Else
				cExitKicker.Enabled = True
			End If
			cExitKicker.Kick kDir, kForce, KickZ
		Else
			For ii = 1 To kickballs
				If cBalls = 0 Or cBallPos(1) <> ii Then Exit For ' No more balls
				For jj = 2 To cBalls    ' Move balls in array
					cBallPos(jj-1) = cBallPos(jj)
				Next
				cBallPos(cBalls) = 0 : cBalls = cBalls - 1 : cUpdate = True
				SetSw ii, False
				If isObject(cExitKicker) Then
					Dim str
					If VPSupBallObj Then
						If IsEmpty(TempBallColour) Then TempBallColour = vpmBallColour
						If IsEmpty(TempBallImage)  Then TempBallImage = vpmBallImage
						str = "With " & cExitKicker.Name & ".CreateBall : " &_
							".Color=" & TempBallColour & " : .Image=""" & TempBallImage & """ : End With : "
					Else
						str = cExitKicker.Name & ".CreateBall : "
					End If
					If kForce < 1 Then kForce = 1
					kDir = kBaseDir + (Rnd - 0.5)*KickAngleVar
					vpmTimer.AddTimer (ii-1)*200, str & cExitKicker.Name & ".Kick " &_
					  CInt(kDir) & "," & Replace(kForce,",",".") & "," & Replace(KickZ,",",".") & " '"
					TempBallColour = cBColour : TempBallImage = cBImage
				End If
				kForce = kForce * 0.8
			Next
		End If
	End Sub

	Public Sub InitSaucer(aKicker, aSw, aDir, aPower)
		InitKick aKicker, aDir, aPower : cSaucer = True
		If aSw Then cSw(1) = aSw Else cSw(1) = aKicker.TimerInterval
	End Sub

	Public Sub InitNoTrough(aKicker, aSw, aDir, aPower)
		InitKick aKicker, aDir, aPower : Balls = 1
		If aSw Then cSw(1) = aSw Else cSw(1) = aKicker.TimerInterval
	End Sub

	Public Sub InitSw(aEntry, aSw1, aSw2, aSw3, aSw4, aSw5, aSw6, aSw7)
		cEntrySw = aEntry : cSw(1) = aSw1 : cSw(2) = aSw2 : cSw(3) = aSw3 : cSw(4) = aSw4
		cSw(5) = aSw5 : cSw(6) = aSw6 : cSw(7) = aSw7
	End Sub

	Public Sub InitKick(aKicker, aDir, aForce)
		Set cExitKicker = aKicker : cExitDir = aDir : cExitForce = aForce
	End Sub

	Public Sub InitAltKick(aDir, aForce)
		cExitDir2 = aDir : cExitForce2 = aForce
	End Sub

	Public Sub InitEntrySnd(aBall, aNoBall) : cEntrySndBall = aBall : cEntrySnd = aNoBall : End Sub
	Public Sub InitExitSnd(aBall, aNoBall)  : cExitSndBall = aBall  : cExitSnd = aNoBall  : End Sub

	Public Property Let Balls(aNoBalls)
		Dim ii
		For ii = 1 To conStackSw
			If cSw(ii) Then Controller.Switch(cSw(ii)) = False
			cBallPos(ii) = 8
		Next
		cBalls = aNoBalls : cUpdate = True
	End Property

	Public Default Property Get Balls       : Balls = cBalls         : End Property
	Public Property Get BallsPending        : BallsPending = cBallIn : End Property
	Public Property Let BallColour(aBallCol) : cBColour = aBallCol : TempBallColour = aBallCol : End Property
	Public Property Let BallImage(aBallImg)  : cBImage  = aBallImg : TempBallImage  = aBallImg : End Property

	' Obsolete stuff
	Public Sub SolEntry(aSnd1, aSnd2, aEnabled)
		If aEnabled Then cEntrySndBall = aSnd1 : cEntrySnd = aSnd2 : KickIn
	End Sub
	Public Sub SolExit(aSnd1, aSnd2, aEnabled)
		If aEnabled Then cExitSndBall = aSnd1 : cExitSnd = aSnd2 : KickOut False
	End Sub
	Public Sub InitProxy(aProxyPos, aSwNo) : End Sub
End Class

'--------------------
'       Nudge
'--------------------
class cvpmNudge
	Private cCount, cSensitivity, cNudgeTimer, cSlingBump, cForce
	Public TiltSwitch

	Private Sub Class_Initialize
		cCount = 0 : TiltSwitch = 0 : cSensitivity = 5
		vpmTimer.AddUpdateObj Me,False : vpmTimer.AddResetObj Me
	End sub

	Public Property Let TiltObj(aSlingBump)
		Dim ii
		ReDim cForce(vpmSetArray(cSlingBump, aSlingBump))
		For ii = 0 To UBound(cForce)
			If TypeName(cSlingBump(ii)) = "Bumper" Then cForce(ii) = cSlingBump(ii).Force Else cForce(ii) = cSlingBump(ii).SlingshotStrength
		Next
	End Property

	Public Property Let Sensitivity(aSens) : cSensitivity = (10-aSens)+1 : End property

	Public Sub DoNudge(ByVal aDir, ByVal aForce)
		aDir = aDir + (Rnd-0.5)*15*aForce : aForce = (0.6+Rnd*0.8)*aForce
		Nudge aDir, aForce
		If TiltSwitch = 0 Then Exit Sub ' If no switch why care
		cCount = cCount + aForce * 1.2
		If cCount > cSensitivity + 10 Then cCount = cSensitivity + 10
		If cCount >= cSensitivity Then vpmTimer.PulseSw TiltSwitch
	End sub

	Public Sub Update
		If cCount > 0 Then
			cNudgeTimer = cNudgeTimer + 1
			If cNudgeTimer > 1000\conTimerPulse Then
				If cCount > cSensitivity+1 Then cCount = cCount - 1 : vpmTimer.PulseSw TiltSwitch
				cCount = cCount - 1 : cNudgeTimer = 0
			End If
		Else
			cCount = 0
		End If
	End Sub

	Public Sub Reset : cCount = 0 : End Sub

	Public Sub SolGameOn(aEnabled)
		Dim obj, ii
		If aEnabled Then
			ii = 0
			For Each obj In cSlingBump
				If TypeName(obj) = "Bumper" Then obj.Force = cForce(ii) Else obj.SlingshotStrength = cForce(ii)
				ii = ii + 1
			Next
		Else
			For Each obj In cSlingBump
				If TypeName(obj) = "Bumper" Then obj.Force = 0 Else obj.SlingshotStrength = 0
			Next
		End If
	End Sub
End Class

'--------------------
'    DropTarget
'--------------------
Class cvpmDropTarget
	Private cDropObj, cDropSw(), cDropSnd, cRaiseSnd, cSwAnyUp, cSwAllDn, cAllDn, cLink

	Private Sub Class_Initialize
		cDropSnd = 0 : cRaiseSnd = 0 : cSwAnyUp = 0 : cSwAllDn = 0 : cAllDn = False : cLink = Empty
	End sub

	Private Sub CheckAllDn(ByVal status)
		Dim obj
		If Not IsEmpty(cLink) Then
			If status Then
				For Each obj In cLink : status = status And obj.AllDown : Next
			End If
			For Each obj In cLink: obj.SetAllDn status : Next
		End If
		SetAllDn status
	End Sub

	Public Sub SetAllDn(status)
		If cSwAllDn Then Controller.Switch(cSwAllDn) = status
		If cSwAnyUp Then Controller.Switch(cSwAnyUp) = Not status
	End Sub

	Public Sub InitDrop(aWalls, aSw)
		Dim obj, obj2, ii
		' Fill in switch number
		On Error Resume Next : ReDim cDropSw(0)
		If IsArray(aSw) Then
			ReDim cDropSw(UBound(aSw))
			For ii = 0 To UBound(aSw) : cDropSw(ii) = aSw(ii) : Next
		ElseIf aSw = 0 Or Err Then
			On Error Goto 0
			If vpmIsArray(aWalls) Then
				ii = 0 : If IsArray(aWalls) Then ReDim cDropSw(UBound(aWalls)) Else ReDim cDropSw(aWalls.Count-1)
				For Each obj In aWalls
					If vpmIsArray(obj) Then
						For Each obj2 In obj
							If obj2.HasHitEvent Then cDropSw(ii) = obj2.TimerInterval : Exit For
						Next
					Else
						cDropSw(ii) = obj.TimerInterval
					End If
					ii = ii + 1
				Next
			Else
				cDropSw(0) = aWalls.TimerInterval
			End If
		Else
			cDropSw(0) = aSw
		End If
		' Copy walls
		vpmSetArray cDropObj, aWalls
	End Sub

	Public Sub CreateEvents(aName)
		Dim ii, obj1, obj2
		If Not vpmCheckEvent(aName, Me) Then Exit Sub
		ii = 1
		For Each obj1 In cDropObj
			If vpmIsArray(obj1) Then
				For Each obj2 In obj1
					If obj2.HasHitEvent Then vpmBuildEvent obj2, "Hit", aName & ".Hit " & ii
				Next
			Else
				vpmBuildEvent obj1, "Hit", aName & ".Hit " & ii
			End If
			ii = ii + 1
		Next
	End Sub

	Public Property Let AnyUpSw(aSwAnyUp)   : cSwAnyUp = aSwAnyUp : Controller.Switch(cSwAnyUp) = True : End Property
	Public Property Let AllDownSw(aSwAllDn) : cSwAllDn = aSwAllDn : End Property
	Public Property Get AllDown : AllDown = cAllDn : End Property
	Public Sub InitSnd(aDrop, aRaise) : cDropSnd = aDrop : cRaiseSnd = aRaise : End Sub
	Public Property Let LinkedTo(aLink)
		If IsArray(aLink) Then cLink = aLink Else cLink = Array(aLink)
	End Property

	Public Sub Hit(aNo)
		Dim ii
		vpmSolWall cDropObj(aNo-1), cDropSnd, True
		Controller.Switch(cDropSw(aNo-1)) = True
		For Each ii In cDropSw
			If Not Controller.Switch(ii) Then Exit Sub
		Next
		cAllDn = True : CheckAllDn True
	End Sub

	Public Sub SolHit(aNo, aEnabled) : If aEnabled Then Hit aNo : End If : End Sub

	Public Sub SolUnhit(aNo, aEnabled)
		Dim ii : If Not aEnabled Then Exit Sub
		PlaySound cRaiseSnd : vpmSolWall cDropObj(aNo-1), False, False
		Controller.Switch(cDropSw(aNo-1)) = False
		cAllDn = False : CheckAllDn False
	End Sub

	Public Sub SolDropDown(aEnabled)
		Dim ii : If Not aEnabled Then Exit Sub
		PlaySound cDropSnd
		For Each ii In cDropObj : vpmSolWall ii, False, True : Next
		For Each ii In cDropSw  : Controller.Switch(ii) = True : Next
		cAllDn = True : CheckAllDn True
	End Sub

	Public Sub SolDropUp(aEnabled)
		Dim ii : If Not aEnabled Then Exit Sub
		PlaySound cRaiseSnd
		For Each ii In cDropObj : vpmSolWall ii, False, False : Next
		For Each ii In cDropSw  : Controller.Switch(ii) = False : Next
		cAllDn = False : CheckAllDn False
	End Sub

	Public Sub DropSol_On : SolDropUp True : End Sub
End Class

'--------------------
'       Magnet
'--------------------
Class cvpmMagnet
	Private cEnabled, cBalls, cTrigger
	Public X, Y, Strength, Size, GrabCenter, Solenoid

	Private Sub Class_Initialize
		Size = 1 : Strength = 0 : Solenoid = 0 : cEnabled = False
		Set cBalls = CreateObject("Scripting.Dictionary") : vpmTimer.addUpdateObj Me,True
	End Sub

	Public Sub InitMagnet(aTrigger, aStrength)
		If vpmIsArray(aTrigger) Then
			X = aTrigger(0).X : Y = aTrigger(0).Y : Size = aTrigger(0).Radius
		Else
			X = aTrigger.X : Y = aTrigger.Y : Size = aTrigger.Radius
		End If
		If IsArray(aTrigger) Then cTrigger = aTrigger Else Set cTrigger = aTrigger
		Strength = aStrength : GrabCenter = aStrength > 14
	End Sub

	Public Sub CreateEvents(aName)
		If vpmCheckEvent(aName, Me) Then
			vpmBuildEvent cTrigger, "Hit", aName & ".AddBall ActiveBall"
			vpmBuildEvent cTrigger, "UnHit", aName & ".RemoveBall ActiveBall"
		End If
	End Sub

	Public Property Let MagnetOn(aEnabled) : cEnabled = aEnabled : End Property
	Public Property Get MagnetOn
		If Solenoid > 0 Then MagnetOn = Controller.Solenoid(Solenoid) Else MagnetOn = cEnabled
	End Property

	Public Sub AddBall(aBall)
		With cBalls : If .Exists(aBall) Then .Item(aBall) = .Item(aBall) + 1  Else .Add aBall, 1 : End If : End With
	End Sub

	Public Sub RemoveBall(aBall)
		With cBalls
			If .Exists(aBall) Then .Item(aBall) = .Item(aBall) - 1 : If .Item(aBall) <= 0 Then .Remove aBall
		End With
	End Sub

	Public Property Get Balls : Balls = cBalls.Keys : End Property

	Public Sub Update
		Dim obj
		If MagnetOn And VPSupBallObj Then
			On Error Resume Next
			For Each obj In cBalls.Keys
				If obj.X < 0 Or Err Then cBalls.Remove obj Else AttractBall obj
			Next
			On Error Goto 0
		End If
	End Sub

	Public Sub AttractBall(aBall)
		Dim dX, dY, dist, force, ratio
		dX = aBall.X - X : dY = aBall.Y - Y : dist = Sqr(dX*dX + dY*dY)
		If dist > Size Or dist < 1 Then Exit Sub 'Just to be safe
		If GrabCenter And dist < 20 Then
			aBall.VelX = 0 : aBall.VelY = 0 : aBall.X = X : aBall.Y = Y
		Else
			ratio = dist / (1.5*Size)
			force = Strength * exp(-0.2/ratio)/(ratio*ratio*56)
			aBall.VelX = (aBall.VelX - dX * force / dist) * 0.985
			aBall.VelY = (aBall.VelY - dY * force / dist) * 0.985
		End if
	End Sub
	' obsolete
	Public Property Let Range(aSize) : Size = aSize : End Property
	Public Property Get Range        : Range = Size : End Property
End Class

'--------------------
'     Turntable
'--------------------
Class cvpmTurntable
	Private cX, cY, cSize, cMotorOn, cDir, cBalls, cTrigger
	Public MaxSpeed, SpinUp, SpinDown, Speed, MotorOn

	Private Sub Class_Initialize
		MotorOn = False : Speed = 0 : cDir = 1 : SpinUp = 10 : SpinDown = 4
		Set cBalls = CreateObject("Scripting.Dictionary") : vpmTimer.AddUpdateObj Me, True
	End Sub

	Public Sub InitTurntable(aTrigger, aMaxSpeed)
		cX = aTrigger.X : cY = aTrigger.Y : cSize = aTrigger.Radius
		MaxSpeed = aMaxSpeed : Set cTrigger = aTrigger
	End Sub

	Public Sub CreateEvents(aName)
		If vpmCheckEvent(aName, Me) Then
			vpmBuildEvent cTrigger, "Hit", aName & ".AddBall ActiveBall"
			vpmBuildEvent cTrigger, "UnHit", aName & ".RemoveBall ActiveBall"
		End If
	End Sub

	Public Sub SolMotorState(aCW, aEnabled)
		MotorOn = aEnabled : If aEnabled Then If aCW Then cDir = 1 Else cDir = -1
	End Sub

	Public Sub AddBall(aBall)    : On Error Resume Next : cBalls.Add aBall,0   : End Sub
	Public Sub RemoveBall(aBall) : On Error Resume Next : cBalls.Remove aBall : End Sub
	Public Property Get Balls : Balls = cBalls.Keys : End Property
	Public Property Let SpinCW(aCW) : If aCW Then cDir = 1 Else cDir = -1 : End If : End Property
	Public Property Get SpinCW      : SpinCW = (cDir = 1) : End Property

	Public Sub Update
		If MotorOn Then
			Speed = Speed + cDir*SpinUp/100
			If cDir * Speed > MaxSpeed Then Speed = cDir * MaxSpeed
		Else
			Speed = Speed - cDir*SpinDown/100
			If cDir * Speed < 0 Then Speed = 0
		End If
		If Speed And VPSupBallObj Then
			Dim obj
			On Error Resume Next
			For Each obj In cBalls.Keys
				If obj.X < 0 Or Err Then cBalls.Remove obj Else AffectBall obj
			Next
			On Error Goto 0
		End If
	End Sub

	Public Sub AffectBall(aBall)
		Dim dX, dY, dist
		dX = aBall.X - cX : dY = aBall.Y - cY : dist = Sqr(dX*dX + dY*dY)
		If dist > cSize Or dist < 1 Or Speed = 0 Then Exit Sub
		aBall.VelX = aBall.VelX - (dY * Speed / 8000)
		aBall.VelY = aBall.VelY + (dX * Speed / 8000)
	End Sub
End Class

'--------------------
'     Mech
'--------------------
Const vpmMechLinear    = &H00
Const vpmMechNonLinear = &H01
Const vpmMechCircle    = &H00
Const vpmMechStopEnd   = &H02
Const vpmMechReverse   = &H04
Const vpmMechOneSol    = &H00
Const vpmMechOneDirSol = &H10
Const vpmMechTwoDirSol = &H20
Const vpmMechStepSol   = &H40
Const vpmMechSlow      = &H00
Const vpmMechFast      = &H80
Const vpmMechStepSw    = &H00
Const vpmMechLengthSw  = &H100

Class cvpmMech
	Public Sol1, Sol2, MType, Length, Steps, Acc, Ret
	Private cMechNo, cNextSw, cSw(), cLastPos, cCallback

	Private Sub Class_Initialize
		ReDim cSw(10)
		gNextMechNo = gNextMechNo + 1 : cMechNo = gNextMechNo : cNextSw = 0 : cLastPos = 0
		MType = 0 : Length = 0 : Steps = 0 : Acc = 0 : Ret = 0
		vpmTimer.addUpdateObj Me, False : vpmTimer.addResetObj Me
	End Sub

	Public Sub AddSw(aSwNo, aStart, aEnd)
		cSw(cNextSw) = Array(aSwNo, aStart, aEnd)
		cNextSw = cNextSw + 1
	End Sub

	Public Sub AddPulseSw(aSwNo, aInterval, aLength) : AddSw aSwNo, -aInterval, aLength : End Sub

	Public Sub Start
		Dim sw, ii
		With Controller
			If .Version < "01000200" Then Exit Sub
			.Mech(1) = Sol1 : .Mech(2) = Sol2 : .Mech(3) = Length
			.Mech(4) = Steps : .Mech(5) = MType : .Mech(6) = Acc : .Mech(7) = Ret
			ii = 10
			For Each sw In cSw
				If IsArray(sw) Then
					.Mech(ii) = sw(0) : .Mech(ii+1) = sw(1) : .Mech(ii+2) = sw(2)
					ii = ii + 10
				End If
			Next
			.Mech(0) = cMechNo
		End With
		If IsObject(cCallback) Then cCallBack 0, 0, 0
	End Sub

	Public Property Get Position : Position = Controller.GetMech(cMechNo) : End Property
	Public Property Get Speed    : Speed = Controller.GetMech(-MechNo)    : End Property
	Public Property Let Callback(aCallBack) : Set cCallback = aCallBack : End Property

	Public Sub Update
		Dim currPos
		If Not IsObject(cCallback) Then Exit Sub
		currPos = Controller.GetMech(cMechNo)
		If cLastPos = currPos Then Exit Sub
		cCallBack currPos, Controller.GetMech(-cMechNo), cLastPos
		cLastPos = currPos
	End Sub

	Public Sub Reset : Start : End Sub
End Class

'--------------------
'   Captive Ball
'--------------------
Class cvpmCaptiveBall
	Private cBallKicked, cBallDir, cBallCos, cBallSin, cTrigHit
	Private cTrig, cWall, cKickers, cVelX, cVelY
	Public ForceTrans, MinForce, BallImage, BallColour, RestSwitch

	Private Sub Class_Initialize
		cBallKicked = False : BallColour = Empty : BallImage = Empty
		ForceTrans = 0.5 : cTrigHit = False : MinForce = 3
		vpmTimer.addResetObj Me
	End Sub

	Public Sub InitCaptive(aTrig, aWall, aKickers, aBallDir)
		Set cTrig = aTrig : Set cWall = aWall
		If IsArray(aKickers) Then cKickers = aKickers Else Set cKickers = aKickers
		cBallDir = aBallDir : cBallCos = Cos(aBallDir * 3.1415927/180) : cBallSin = Sin(aBallDir * 3.1415927/180)
	End Sub

	Public Sub Start
		If IsEmpty(BallColour) Then BallColour = vpmBallColour
		If IsEmpty(BallImage) Then BallImage = vpmBallImage
		With cKickers(UBound(cKickers)-1).CreateBall : .Image = BallImage : .Color = BallColour : End With
		If RestSwitch Then Controller.Switch(RestSwitch) = True
	End Sub

	Public Sub TrigHit(aBall)
		cTrigHit = IsObject(aBall) : If cTrigHit Then cVelX = aBall.VelX : cVelY = aBall.VelY
	End Sub

	Public Sub Reset : If RestSwitch Then Controller.Switch(RestSwitch) = True : End If : End Sub

	Public Sub BallHit(aBall)
		Dim dX, dY, force
		If cBallKicked Then Exit Sub ' Ball is not here
		If cTrigHit Then cTrigHit = False Else cVelX = aBall.VelX : cVelY = aBall.VelY
		dX = aBall.X - cKickers(0).X : dY = aBall.Y - cKickers(0).Y
		force = -ForceTrans * (dY * cVelY + dX * cVelX) * (dY * cBallCos + dX * cBallSin) / (dX*dX + dY*dY)
		If force < 1 Then Exit Sub
		If force < MinForce Then force = MinForce
		With cKickers(UBound(cKickers)).CreateBall : .Image = BallImage : .Color = BallColour : End With
		cKickers(UBound(cKickers)).Kick cBallDir, force : cKickers(UBound(cKickers)-1).DestroyBall : cBallKicked = True
		If RestSwitch Then Controller.Switch(RestSwitch) = False
	End Sub

	Public Sub BallReturn(aKicker)
		With cKickers(UBound(cKickers)-1).CreateBall : .Image = BallImage : .Color = BallColour : End With
		aKicker.DestroyBall : cBallKicked = False
		If RestSwitch Then Controller.Switch(RestSwitch) = True
	End Sub

	Public Sub CreateEvents(aName)
		If vpmCheckEvent(aName, Me) Then
			If Not cTrig Is Nothing Then
				vpmBuildEvent cTrig, "Hit", aName & ".TrigHit ActiveBall"
				vpmBuildEvent cTrig, "UnHit", aName & ".TrigHit 0"
			End If
			vpmBuildEvent cWall, "Hit", aName & ".BallHit ActiveBall"
			vpmBuildEvent cKickers(UBound(cKickers)), "Hit", aName & ".BallReturn Me"
		End If
	End Sub
End Class

'--------------------
'   Visible Locks
'--------------------
Class cvpmVLock
	Private cTrig, cKick, cSw(), cSize, cBalls, cGateOpen, cRealForce, cBallSnd, cNoBallSnd
	Public ExitDir, ExitForce, KickForceVar

	Private Sub Class_Initialize
		cBalls = 0 : ExitDir = 0 : ExitForce = 0 : KickForceVar = 0 : cGateOpen = False
		vpmTimer.addResetObj Me
	End Sub

	Public Sub InitVLock(aTrig, aKick, aSw)
		Dim ii
		cSize = vpmSetArray(cTrig, aTrig)
		If vpmSetArray(cKick, aKick) <> cSize Then MsgBox "cvpmVLock: Unmatched kick+trig" : Exit Sub
		On Error Resume Next
		ReDim cSw(cSize)
		If IsArray(aSw) Then
			For ii = 0 To UBound(aSw) : cSw(ii) = aSw(ii) : Next
		ElseIf aSw = 0 Or Err Then
			For ii = 0 To cSize: cSw(ii) = cTrig(ii).TimerInterval : Next
		Else
			cSw(0) = aSw
		End If
	End Sub

	Public Sub InitSnd(aBall, aNoBall) : cBallSnd = aBall :	cNoBallSnd = aNoBall : End Sub
	Public Sub CreateEvents(aName)
		Dim ii
		If Not vpmCheckEvent(aName, Me) Then Exit Sub
		For ii = 0 To cSize
			vpmBuildEvent cTrig(ii), "Hit", aName & ".TrigHit ActiveBall," & ii+1
			vpmBuildEvent cTrig(ii), "Unhit", aName & ".TrigUnhit ActiveBall," & ii+1
			vpmBuildEvent cKick(ii), "Hit", aName & ".KickHit " & ii+1
		Next
	End Sub

	Public Sub SolExit(aEnabled)
		Dim ii
		cGateOpen = aEnabled
		If Not aEnabled Then Exit Sub
		If cBalls > 0 Then PlaySound cBallSnd : Else PlaySound cNoBallSnd : Exit Sub
		' "merged" balls may not be catched in the kicker. Ensure all are disabled
		For ii = 0 To cBalls-1 : cKick(ii).Enabled = False : Next
		If ExitForce > 0 Then ' Up
			cRealForce = ExitForce + (Rnd - 0.5)*KickForceVar : cKick(cBalls-1).Kick ExitDir, cRealForce
		Else ' Down
			cKick(0).Kick 0, 0
		End If
	End Sub

	Public Sub Reset
		If cBalls = 0 Then Exit Sub
		For ii = 0 To cBalls-1
			If cSw(ii) Then Controller.Switch(cSw(ii)) = True
		Next
	End Sub

	Public Property Get Balls : Balls = cBalls : End Property

	Public Sub TrigHit(aBall, aNo)
		aNo = aNo - 1 : If cSw(aNo) Then Controller.Switch(cSw(aNo)) = True
		If aBall.VelY < 0 Then Exit Sub
		If aNo = cSize Then cBalls = cBalls + 1
		If cBalls > aNo Then cKick(aNo).Enabled = Not cGateOpen
	End Sub

	Public Sub TrigUnHit(aBall, aNo)
		aNo = aNo - 1 : If cSw(aNo) Then Controller.Switch(cSw(aNo)) = False
		If aBall.VelY > 0 Then
			If aNo = 0 Then cBalls = cBalls - 1
			If aNo < cSize Then cKick(aNo+1).Kick 0, 0
		Else
			If aNo = cSize Then cBalls = cBalls - 1
			If aNo > 0 Then cKick(aNo-1).Kick ExitDir, cRealForce
		End If
	End Sub

	Public Sub KickHit(aNo) : cKick(aNo-1).Enabled = False : End Sub
End Class

'--------------------
'   View Dips
'--------------------
Class cvpmDips
	Private cLWF, cChkCount, cOptCount, cChkData(), cOptData()

	Private Sub Class_Initialize
		ReDim cChkData(100), cOptData(100)
	End Sub

	Public Sub addForm(ByVal aWidth, aHeight, aName)
		If isObject(cLWF) Then
			cLWF.DeleteForm
		Else
			On Error Resume Next
				Set cLWF = CreateObject("wshLtWtForm.ucLWF") : If Err Then Exit Sub
			On Error Goto 0
		End If
		If aWidth < 80 Then aWidth = 80
		cLWF.CreateForm 320-aWidth\2,0,CInt(aWidth),aHeight+60,cStr(aName)
		cLWF.AddCtrl "CmdBtn", (aWidth-70)\2, CInt(aHeight), 70, 30, "&Ok"
		cChkCount = 0 : cOptCount = 0
	End Sub

	Public Sub addChk(aLeft, aTop, aWidth, aNames)
		Dim ii
		If Not isObject(cLWF) Then Exit Sub
		For ii = 0 To UBound(aNames) Step 2
			cLWF.AddCtrl "chkBox", CInt(aLeft), aTop+ii*7, CInt(aWidth), 14, CStr(aNames(ii))
			cChkCount = cChkCount + 1 : cChkData(cChkCount) = aNames(ii+1)
		Next
	End Sub

	Public Sub addFrame(aLeft, aTop, aWidth, aHeading, aMask, aNames)
		Dim ii
		If Not isObject(cLWF) Then Exit Sub
		cLWF.AddCtrl "Frame", CInt(aLeft), CInt(aTop), aWidth+10, 7*UBound(aNames)+25, CStr(aHeading)
		If aMask Then
			For ii = 0 To UBound(aNames) Step 2
				cLWF.AddCtrl "OptBtn", 5, ii*7+14, CInt(aWidth), 14, CStr(aNames(ii))
				cOptCount = cOptCount + 1 : cOptData(cOptCount) = Array(aMask,aNames(ii+1))
			Next
		Else
			addChk 5, 15, aWidth, aNames
		End If
	End Sub

	Public Sub addLabel(aLeft, aTop, aWidth, aHeight, aCaption)
		If Not isObject(cLWF) Then Exit Sub
		cLWF.AddCtrl "Label",CInt(aLeft),CInt(aTop),CInt(aWidth),CInt(aHeight),CStr(aCaption)
	End Sub

	Public Sub viewDips
		Dim dips,ii
		If Not isObject(cLWF) Then Exit Sub
		With Controller
			dips = .Dip(0) + .Dip(1)*&H100 + .Dip(2)*&H10000 + (.Dip(3) And &H7f)*&H1000000
			If .Dip(3) And &H80 Then dips = dips Or &H80000000 'workaround for overflow error
		End With
		With cLWF.frmDialog
			If cChkCount > 0 Then
				For ii = 1 To cChkCount : .ChkBox(ii).Value = -((dips And cChkData(ii))<>0) : Next
			End If
			If cOptCount > 0 Then
				For ii = 1 To cOptCount : .Option(ii).Value = -((dips And cOptData(ii)(0)) = cOptData(ii)(1)) : Next
			End If
			dips = 0 : cLWF.ShowForm
			If cChkCount > 0 Then
				For ii = 1 To cChkCount
					If .ChkBox(ii).Value Then dips = dips Or cChkData(ii)
				Next
			End If
			If cOptCount > 0 Then
				For ii = 1 To cOptCount
					If .Option(ii).Value Then dips = dips Or cOptData(ii)(1)
				Next
			End If
		End With
		With Controller : .Dip(0) = dips : .Dip(1) = dips\&H100 : .Dip(2) = dips\&H10000 : .Dip(3) = dips\&H1000000 : End With
	End Sub
End Class

Set vpmTimer = New cvpmTimer
Set vpmNudge = New cvpmNudge

Sub PulseTimer_Init  : vpmTimer.InitTimer Me : End Sub
Sub PulseTimer_Timer : vpmTimer.Update       : End Sub
Sub vpmFastTimer_Init : Me.Interval = conTimerPulse \ conFastTicks : Me.Enabled = True : End Sub
Sub vpmFastTimer_Timer : vpmTimer.UpdateFast : End Sub

Private VPSupBallObj, vpmNoMTimer
Sub PinMAMETimer_Init
	Me.Interval = PinMAMEInterval : Me.Enabled = True
	' backward compability tests
	VPSupBallObj = False : On Error Resume Next
	VPSupBallObj = StartGameKey > 0 : If VPSupBallObj Then keyStartButton = StartGameKey
End Sub
On Error Resume Next
If vpmFastTimer.Interval < 0 Or Err Then vpmNoMTimer = True
On Error Goto 0

Private Const CHGNO = 0
Private Const CHGSTATE = 1

Sub vpmDoSolCallback(aNo, aEnabled)
	If SolCallback(aNo) <> "" Then Execute SolCallback(aNo) & " CBool(" & CInt(aEnabled) &")"
End Sub

Sub vpmDoLampUpdate(aNo, aEnabled)
	On Error Resume Next : Lights(aNo).State = Abs(aEnabled) : On Error Goto 0
End Sub

'-------------------
' Main Loop
'------------------
Sub PinMAMETimer_Timer
	Dim ChgLamp,ChgSol,ChgGI, ii, tmp
	Me.Enabled = False
	On Error Resume Next
		Controller.Pause = True
			If UseLamps Then ChgLamp = Controller.ChangedLamps Else LampCallback
			If UseSolenoids Then ChgSol  = Controller.ChangedSolenoids
			If isObject(GICallback) Then ChgGI = Controller.ChangedGIStrings
			MotorCallback
		Controller.Pause = False
	On Error Goto 0
	If Not IsEmpty(ChgLamp) Then
		On Error Resume Next
			For ii = 0 To UBound(ChgLamp)
				Lights(ChgLamp(ii, CHGNO)).State = ChgLamp(ii, CHGSTATE)
			Next
			For Each tmp In vpmMultiLights
				For ii = 1 To UBound(tmp) : tmp(ii).State = tmp(0).State : Next
			Next
			LampCallback
		On Error Goto 0
	End If
	If Not IsEmpty(ChgSol) Then
		For ii = 0 To UBound(ChgSol)
			tmp = SolCallback(ChgSol(ii, CHGNO))
			If tmp <> "" Then Execute tmp & " CBool(" & CInt(ChgSol(ii, CHGSTATE)) &")"
		Next
	End If
	If Not IsEmpty(ChgGI) Then
		For ii = 0 To UBound(ChgGI)
			GICallback ChgGI(ii, CHGNO), CBool(ChgGI(ii, CHGSTATE))
		Next
	End If
	Me.Enabled = True
End Sub

Private Sub vpmPlaySound(aEnabled, aSound)
	If VarType(aSound) = vbString Then
		If aEnabled Then StopSound aSound : PlaySound aSound
	ElseIf aSound Then
		If aEnabled Then PlaySound SSolenoidOn Else PlaySound SSolenoidOff
	End If
End Sub

Private Sub vpmToggleObj(aObj, aEnabled)
	Select Case TypeName(aObj)
		Case "Wall"                        aObj.IsDropped = aEnabled
		Case "Bumper", "Light"             aObj.State     = Abs(aEnabled)
		Case "Kicker", "Trigger", "Timer"  aObj.Enabled   = aEnabled
		Case "Gate"                        aObj.Open      = aEnabled
		Case "Integer"                     Controller.Switch(aObj) = aEnabled
		Case Else MsgBox "vpmToggleObj: Unhadled Object " & TypeName(aObj)
	End Select
End Sub

Private Function vpmCheckEvent(aName, obj)
	vpmCheckEvent = True
	On Error Resume Next
	If Not Eval(aName) Is obj Or Err Then MsgBox "CreateEvents: Wrong name " & aName : vpmCheckEvent = False
	On Error Goto 0
End Function

Private Sub vpmBuildEvent(aObj, aEvent, aTask)
	Dim obj, str
	str = "_" & aEvent & " : " & aTask & " : End Sub"
	If vpmIsArray(aObj) Then
		For Each obj In aObj : ExecuteGlobal "Sub " & obj.Name & str : Next
	Else
		ExecuteGlobal "Sub " & aObj.Name & str
	End If
End Sub

Private Function vpmIsArray(aObj) : vpmIsArray = IsArray(aObj) Or TypeName(aObj) = "ICollection" : End Function

Private Function vpmSetArray(aTo, aFrom)
	If IsArray(aFrom) Then
		aTo = aFrom : vpmSetArray = UBound(aFrom)
	ElseIf TypeName(aFrom) = "ICollection" Then
		Set aTo = aFrom : vpmSetArray = aFrom.Count - 1
	Else
		aTo = Array(aFrom) : vpmSetArray = 0
	End If
End Function

Sub vpmCreateEvents(aHitObjs)
	Dim obj
	For Each obj In aHitObjs
		Select Case TypeName(obj)
			Case "Trigger"
				vpmBuildEvent obj, "Hit", "Controller.Switch(" & Obj.TimerInterval & ") = True"
				vpmBuildEvent obj, "UnHit", "Controller.Switch(" & Obj.TimerInterval & ") = False"
			Case "Wall"
				If obj.HasHitEvent Then
					vpmBuildEvent obj, "Hit", "vpmTimer.PulseSw " & Obj.TimerInterval
				Else
					vpmBuildEvent obj, "SlingShot", "vpmTimer.PulseSw " & Obj.TimerInterval
				End If
			Case "Bumper", "Gate"
				vpmBuildEvent obj, "Hit","vpmTimer.PulseSw " & Obj.TimerInterval
			Case "Spinner"
				vpmBuildEvent obj, "Spin","vpmTimer.PulseSw " & Obj.TimerInterval
		End Select
	Next
End Sub

Sub vpmMapLights(aLights)
	Dim obj
	For Each obj In aLights
		If IsObject(Lights(obj.TimerInterval)) Then
			ReDim Preserve vpmMultiLights(UBound(vpmMultiLights)+1)
			vpmMultiLights(UBound(vpmMultiLights)) = Array(Lights(obj.TimerInterval),obj)
		Else
			Set Lights(obj.TimerInterval) = obj
		End If
	Next
End Sub

Function vpmMoveBall(aBall, aFromKick, aToKick)
    With aToKick.CreateBall
    	If TypeName(aBall) = "Ball" Then
			.Color = aBall.Color   : .Image = aBall.Image
    	Else
			.Color = vpmBallColour : .Image = vpmBallImage
    	End If
	End With
	aFromKick.DestroyBall
	Set vpmMoveBall = aToKick
End Function

'----------------------------
' Generic solenoid handlers
'----------------------------
' ----- Flippers ------
Sub vpmSolFlipper(aFlip1, aFlip2, aEnabled)
	Dim oldSpeed
	If aEnabled Then
		PlaySound SFlipperOn : aFlip1.RotateToEnd : If Not aFlip2 Is Nothing Then aFlip2.RotateToEnd
	Else
		PlaySound SFlipperOff
		oldSpeed = aFlip1.Speed : aFlip1.Speed = 0.03
		aFlip1.RotateToStart : aFlip1.Speed = oldSpeed
		If Not aFlip2 Is Nothing Then
			oldSpeed = aFlip2.Speed : aFlip2.Speed = 0.03
			aFlip2.RotateToStart : aFlip2.Speed = oldSpeed
		End If
	End If
End Sub

' ------ Diverters ------
Sub vpmSolDiverter(aDiv, aSound, aEnabled)
	If aEnabled Then aDiv.RotateToEnd : Else aDiv.RotateToStart
	vpmPlaySound aEnabled, aSound
End sub

' ------ Walls ------
Sub vpmSolWall(aWall, aSound, aEnabled)
	Dim obj
	If vpmIsArray(aWall) Then
		For Each obj In aWall : obj.IsDropped = aEnabled : Next
	Else
		aWall.IsDropped = aEnabled
	End If
	vpmPlaySound aEnabled, aSound
End Sub

Sub vpmSolToggleWall(aWall1, aWall2, aSound, aEnabled)
	Dim obj
	If vpmIsArray(aWall1) Then
		For Each obj In aWall1 : obj.IsDropped = aEnabled : Next
	Else
		aWall1.IsDropped = aEnabled
	End If
	If vpmIsArray(aWall2) Then
		For Each obj In aWall2 : obj.IsDropped = Not aEnabled : Next
	Else
		aWall2.IsDropped = Not aEnabled
	End If
	vpmPlaySound aEnabled, aSound
End Sub

' ------- Autoplunger ------
Sub vpmSolAutoPlunger(aPlung, aVar, aEnabled)
	Dim oldFire
	If aEnabled Then
		oldFire = aPlung.FireSpeed : aPlung.FireSpeed = oldFire * (100-aVar*(2*Rnd-1))/100
		PlaySound SSolenoidOn : aPlung.Fire : aPlung.FireSpeed = oldFire
	Else
		aPlung.Pullback
	End If
End Sub

' --------- Gate -----------
Sub vpmSolGate(aGate, aSound, aEnabled)
	Dim obj
	If vpmIsArray(aGate) Then
		For Each obj In aGate : obj.Open = aEnabled : Next
	Else
		aGate.Open = aEnabled
	End If
	vpmPlaySound aEnabled, aSound
End Sub

' ------ Sound Only -------
Sub vpmSolSound(aSound, aEnabled)
	If aEnabled Then StopSound aSound : PlaySound aSound
End Sub

' ------- Flashers --------
Sub vpmFlasher(aFlash, aEnabled)
	Dim obj
	If vpmIsArray(aFlash) Then
		For Each obj In aFlash : obj.State = Abs(aEnabled) : Next
	Else
		aFlash.State = Abs(aEnabled)
	End If
End Sub

'---- Generic object toggle ----
Sub vpmSolToggleObj(aObj1, aObj2, aSound, aEnabled)
	Dim obj
	If vpmIsArray(aObj1) Then
		If IsArray(aObj1(0)) Then
			For Each obj In aObj1(0) : vpmToggleObj obj, aEnabled     : Next
			For Each obj In aObj1(1) : vpmToggleObj obj, Not aEnabled : Next
		Else
			For Each obj In aObj1    : vpmToggleObj obj, aEnabled     : Next
		End If
	ElseIf Not aObj1 Is Nothing Then
		vpmToggleObj aObj1, aEnabled
	End If
	If vpmIsArray(aObj2) Then
		If IsArray(aObj2(0)) Then
			For Each obj In aObj2(0) : vpmToggleObj obj, Not aEnabled : Next
			For Each obj In aObj2(1) : vpmToggleObj obj, aEnabled     : Next
		Else
			For Each obj In aObj2    : vpmToggleObj obj, Not aEnabled : Next
		End If
	ElseIf Not aObj2 Is Nothing Then
		vpmToggleObj aObj2, Not aEnabled
	End If
	vpmPlaySound aEnabled, aSound
End Sub

'
' Stubs to allow older games to still work
' These will be removed one day
'
Sub SolFlipper(f1,f2,e) : vpmSolFlipper f1,f2,e : End Sub
Sub SolDiverter(d,s,e) : vpmSolDiverter d,s,e : End Sub
Sub SolSound(s,e) : vpmSolSound s,e : End Sub
Sub Flasher(f,e) : vpmFlasher f,e : End Sub
Sub SolMagnet(m,e) : vpmSolMagnet m,e : End Sub
Sub SolAutoPlunger(p,e) : vpmSolAutoPlunger p,0,e : End Sub
Function KeyDownHandler(ByVal k) : KeyDownHandler = vpmKeyDown(k) : End Function
Function KeyUpHandler(ByVal k) : KeyUpHandler = vpmKeyUp(k) : End Function
Function KeyName(ByVal k) : KeyName = vpmKeyName(k) : End Function
Sub vpmSolMagnet(m,e) : m.Enabled = e : If Not e Then m.Kick 180,1 : End If : End Sub

'-- Flipper solenoids (all games)
Const sLRFlipper = 46
Const sLLFlipper = 48
Const sURFlipper = 34
Const sULFlipper = 36

' Convert keycode to readable string
Private keyNames1, keyNames2
keyNames1 = Array("Escape","1","2","3","4","5","6","7","8","9","0","Minus '-'",_
"Equals '='","Backspace","Tab","Q","W","E","R","T","Y","U","I","O","P","[","]",_
"Enter","Left Ctrl","A","S","D","F","G","H","J","K","L",";","'","`","Left Shift",_
"\","Z","X","C","V","B","N","M",",",".","/","Right Shift","*","Left Menu","Space",_
"Caps Lock","F1","F2","F3","F4","F5","F6","F7","F8","F9","F10","NumLock","ScrlLock",_
"Numpad 7","Numpad 8","Numpad 9","Numpad -","Numpad 4","Numpad 5","Numpad 6",_
"Numpad +","Numpad 1","Numpad 2","Numpad 3","Numpad 0","Numpad .","?","?","?",_
"F11","F12","F13","F14","F15")
keyNames2 = Array("Pause","?","Home","Up","PageUp","?","Left","?","Right","?",_
"End","Down","PageDown","Insert","Delete")

Function vpmKeyName(ByVal aKeycode)
	If aKeyCode-1 <= UBound(keyNames1) Then
		vpmKeyName = keyNames1(aKeyCode-1)
	ElseIf aKeyCode >= 197 And aKeyCode <= 211 Then
		vpmKeyName = keyNames2(aKeyCode-197)
	ElseIf aKeyCode = 184 Then
		vpmKeyName = "R.Alt"
	Else
		vpmKeyName = "?"
	End If
End Function

On Error Resume Next
ExecuteGlobal CreateObject("Scripting.FileSystemObject").OpenTextFile("VPMKeys.vbs", 1).ReadAll
If Err Then MsgBox "Can't open ""VPMKeys.vbs""." & vbNewLine & "Ensure that it is in the same folder as this table"
On Error Goto 0

Private vpmSystemHelp
Private Sub vpmShowHelp
	Dim szKeyMsg
	szKeyMsg = "The following keys are defined: "                  & vbNewLine &_
	           "(American keyboard layout)"                        & vbNewLine &_
		vbNewLine & "Visual PinMAME keys:"                         & vbNewLine &_
		vpmKeyName(keyShowOpts)   & vbTab & "Game options..."      & vbNewLine &_
		vpmKeyName(keyShowKeys)   & vbTab & "Keyboard settings..." & vbNewLine &_
		vpmKeyName(keyReset)      & vbTab & "Reset emulation"      & vbNewLine &_
		vpmKeyName(keyFrame)      & vbTab & "Toggle Display lock"  & vbNewLine &_
		vpmKeyName(keyDoubleSize) & vbTab & "Toggle Display size"  & vbNewLine
		If isObject(vpmShowDips) Then
			szKeyMsg = szKeyMsg & vpmKeyName(keyShowDips)   & vbTab & "Show DIP switches" & vbNewLine
		End If
	szKeyMsg = szKeyMsg & vpmKeyName(keyBangBack) & vbTab & "Bang Back" & vbNewLine &_
		vbNewLine & vpmSystemHelp & vbNewLine
	If ExtraKeyHelp <> "" Then
		szKeyMsg = szKeyMsg & vbNewLine & "Game Specific keys:" &_
			vbNewLine & ExtraKeyHelp & vbNewLine
	End If
	szKeyMsg = szKeyMsg & vbNewLine & "Visual Pinball keys:"     & vbNewLine &_
		vpmKeyName(LeftFlipperKey)  & vbTab & "Left Flipper"     & vbNewLine &_
		vpmKeyName(RightFlipperKey) & vbTab & "Right Flipper"    & vbNewLine &_
		vpmKeyName(PlungerKey)      & vbTab & "Launch Ball"      & vbNewLine &_
		vpmKeyName(keyStartButton)  & vbTab & "Start Button"     & vbNewLine &_
		vpmKeyName(LeftTiltKey)     & vbTab & "Nudge from Left"  & vbNewLine &_
		vpmKeyName(RightTiltKey)    & vbTab & "Nudge from Right" & vbNewLine &_
		vpmKeyName(CenterTiltKey)   & vbTab & "Nudge forward"    & vbNewLine
	MsgBox szKeyMsg,0,"Keyboard Settings..."
End Sub
'-------------------------
' Bally Data
'-------------------------
' Cabinet switches
Const swSelfTest       = -7
Const swCPUDiag        = -4
Const swSoundDiag      = -3
Const swTilt           =  7
Const swBallRollTilt   =  2
Const swSlamTilt       = 16
Const swCoin3          =  9
Const swCoin2          = 10
Const swCoin1          = 11
Const swStartButton    =  6

Const swLRFlip         = 82
Const swLLFlip         = 84

' Help Window
vpmSystemHelp = "Bally -17/-35 keys:" & vbNewLine &_
  vpmKeyName(keyInsertCoin1) & vbTab & "Insert Coin #1"   & vbNewLine &_
  vpmKeyName(keyInsertCoin2) & vbTab & "Insert Coin #2"   & vbNewLine &_
  vpmKeyName(keyInsertCoin3) & vbTab & "Insert Coin #3"   & vbNewLine &_
  vpmKeyName(keySelfTest)    & vbTab & "Self Test"        & vbNewLine &_
  vpmKeyName(keyCPUDiag)     & vbTab & "Cpu Diagnostic"   & vbNewLine &_
  vpmKeyName(keySoundDiag)   & vbTab & "Sound Diagnostic" & vbNewLine &_
  vpmKeyName(keySlamDoorHit) & vbTab & "Slam Tilt"

Private Sub ballyShowDips
	Dim vpmDips : Set vpmDips = New cvpmDips
	With vpmDips
		.AddForm 150, 245, "DIP switches"
		.AddFrame  0,0, 60, "", 0,_
		  Array("DIP  1",&H00000001,"DIP  2",&H00000002,"DIP  3",&H00000004,"DIP  4",&H00000008,_
		        "DIP  5",&H00000010,"DIP  6",&H00000020,"DIP  7",&H00000040,"DIP  8",&H00000020,_
		        "DIP  9",&H00000100,"DIP 10",&H00000200,"DIP 11",&H00000400,"DIP 12",&H00000800,_
		        "DIP 13",&H00001000,"DIP 14",&H00002000,"DIP 15",&H00004000,"DIP 16",&H00008000)
		.AddFrame 80,0, 60, "", 0,_
		  Array("DIP 17",&H00010000,"DIP 18",&H00020000,"DIP 19",&H00040000,"DIP 20",&H00080000,_
		        "DIP 21",&H00100000,"DIP 22",&H00200000,"DIP 23",&H00400000,"DIP 24",&H00800000,_
		        "DIP 25",&H01000000,"DIP 26",&H02000000,"DIP 27",&H04000000,"DIP 28",&H08000000,_
		        "DIP 29",&H10000000,"DIP 30",&H20000000,"DIP 31",&H40000000,"DIP 32",&H80000000)
		.ViewDips
	End With
End Sub
Set vpmShowDips = GetRef("ballyShowDips")

' Keyboard handlers
Function vpmKeyDown(ByVal keycode)
	On Error Resume Next ' SCoin
	vpmKeyDown = True ' Assume we handle the key
	With Controller
		Select Case keycode
			Case keyInsertCoin1  vpmTimer.AddTimer 750,"vpmTimer.PulseSw swCoin1'" : Playsound SCoin
			Case keyInsertCoin2  vpmTimer.AddTimer 750,"vpmTimer.PulseSw swCoin2'" : Playsound SCoin
			Case keyInsertCoin3  vpmTimer.AddTimer 750,"vpmTimer.PulseSw swCoin3'" : Playsound SCoin
			Case keyStartButton  .Switch(swStartButton) = True
			Case LeftFlipperKey  .Switch(swLLFlip)      = True
			Case RightFlipperKey .Switch(swLRFlip)      = True
			Case keySelfTest     .Switch(swSelfTest)    = True
			Case keyCPUDiag      .Switch(swCPUDiag)     = True
			Case keySoundDiag    .Switch(swSoundDiag)   = True
			Case keySlamDoorHit  .Switch(swSlamTilt)    = True
			Case keyBangBack     vpmNudge.DoNudge   0, 6
			Case LeftTiltKey     vpmNudge.DoNudge  75, 2
			Case RightTiltKey    vpmNudge.DoNudge 285, 2
			Case CenterTiltKey   vpmNudge.DoNudge   0, 2
			Case Else            vpmKeyDown = False
		End Select
	End With
	On Error Goto 0
End Function

Function vpmKeyUp(ByVal keycode)
	vpmKeyUp = True ' Assume we handle the key
	With Controller
		Select Case keycode
			Case keyStartButton  .Switch(swStartButton) = False
			Case LeftFlipperKey  .Switch(swLLFlip)      = False
			Case RightFlipperKey .Switch(swLRFlip)      = False
			Case keySelfTest     .Switch(swSelfTest)    = False
			Case keyCPUDiag      .Switch(swCPUDiag)     = False
			Case keySoundDiag    .Switch(swSoundDiag)   = False
			Case keySlamDoorHit  .Switch(swSlamTilt)    = False
			Case keyShowOpts     .Pause = True : .ShowOptsDialog GetPlayerHWnd : .Pause = False
			Case keyShowKeys     .Pause = True : vpmShowHelp : .Pause = False
			Case keyShowDips     If IsObject(vpmShowDips) Then .Pause = True : vpmShowDips : .Pause = False
			Case keyReset        .Stop : .Run : vpmTimer.Reset
			Case keyFrame        .LockDisplay = Not .LockDisplay
			Case keyDoubleSize   .DoubleSize  = Not .DoubleSize
			Case Else            vpmKeyUp = False
		End Select
	End With
End Function

